#by default including class is expected to store frequency in mins
#expects the frequency column in minutes
#TODO: Move key storage to has storage with lock for faster enqueuing and look up

require 'sk_requeue/core'

module SkRequeue

  def set_up_worker(options={})
    class_attribute :worker_config, :worker_name, :frequency_column

    worker_name = options.fetch(:worker_name, "HardWorker")
    frequency_column = options.fetch(:frequency_column, "frequency")

    self.worker_config = {worker_name: worker_name, frequency_column: frequency_column}
    self.worker_name = worker_name
    self.frequency_column = frequency_column

    include SkRequeue::Core
  end

end

ActiveRecord::Base.extend SkRequeue
